# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
#
# Copyright (C) 2013 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Nicholas Skaggs <nicholas.skaggs@canonical.com>


class MainWindow(object):
    """An emulator class that makes it easy to interact with the CurrencyConverter."""

    def __init__(self, app):
        self.app = app

    def get_clear_button(self):
        """Returns the clear button object"""
        return self.app.select_single("Button", objectName="clearBtn")

    def get_from_currency_field(self):
        """Returns the from currency field"""
        return self.app.select_single("TextField", objectName="inputFrom")

    def get_to_currency_field(self):
        """Returns the to currency field"""
        return self.app.select_single("TextField", objectName="inputTo")

    def get_from_currency_button(self):
        """Returns the select for the from currency field"""
        return self.app.select_single("Button", objectName="selectorFrom")

    def get_to_currency_button(self):
        """Returns the select for the to currency field"""
        return self.app.select_single("Button", objectName="selectorTo")
