/**
 * Wait before the DOM has been loaded before initializing the Ubuntu UI layer
 */
window.onload = function () {
    var UI = new UbuntuUI();
    UI.init();
    UI.pagestack.push('main');
    var api = external.getUnityObject('1.0');
    var oa = api.OnlineAccounts;

    UI.button('getalbums').click(auth);
    var photosdiv = document.querySelector('#presults')
    var lalbums = UI.list('#albums');
    var token = '';

    function auth() {
        UI.pagestack.clear();
        lalbums.removeAllItems();
        setResults('');
        UI.pagestack.push('albumspage');
        document.getElementById('progress').style.display='block';

        var filters = {'provider': 'facebook', 'service': ''};

        oa.api.getAccounts(filters, function(accounts) {
            document.getElementById('progress').style.display='none';
            if (accounts.length < 1) {
                setResults('No facebook accounts enabled');
                return;
            }

            function authcallback(res){
                token = res['data']['AccessToken'];

                getFacebookAlbums(token, function(albums) {
                    if (albums) {
                        for (var i = 0; i < albums.length; ++i) {
                            var name = albums[i]['name'];
                            var id = albums[i]['id'];
                            var getPhotos = getFacebookPhotosForAlbum(id, token, function(photos) {
                                for (i2=0; i2<photos.length; i2++) {
                                    var shape = document.createElement('div');
                                    shape.setAttribute('data-role', "shape");
                                    shape.setAttribute('id', photos[i2]);
                                    var img = document.createElement('img');
                                    img.setAttribute('src', photos[i2]);
                                    img.setAttribute('width', '120');
                                    shape.appendChild(img);
                                    photosdiv.appendChild(shape);
                                    (function(pic){
                                        UI.shape(pic).click(function(){
                                        UI.pagestack.push('photopage');
                                        document.getElementById('photoimg').setAttribute('src', pic);
                                        });
                                    })(photos[i2]);
                                }
                            });
                            lalbums.append(
                                name.slice(1,name.length-1) + ' ' + id.slice(1,id.length-1),
                                null,
                                null,
                                getPhotos);
                        }
                    }
                    else {
                        setResults('<br><br>ERROR');
                    }
                });
            }
            accounts[0].authenticate(authcallback);
        }); //getAccounts
    } //auth

    function getFacebookPhotosForAlbum(albumId, accessToken, callback) {
        return function() {
            while (photosdiv.hasChildNodes()) {
                photosdiv.removeChild(photosdiv.lastChild);
            }
            var http = new XMLHttpRequest()
            UI.pagestack.push('albumpage');
            var url = "https://graph.facebook.com/" +
                albumId.slice(1,albumId.length-1) +
                "?fields=photos&access_token=" +
                accessToken;
            http.open("GET", url, true);
            var photos = [];
            http.onreadystatechange = function() {
                if (http.readyState === 4){
                    if (http.status == 200) {
                        var response = JSON.parse(http.responseText);
                        for (i = 0; i<response['photos']['data'].length; i++ ) {
                            var picture = JSON.stringify(response['photos']['data'][i]['images'][0]['source']);
                            picture = picture.slice(1,picture.length-1);
                            photos.push(picture);
                        }
                        callback(photos);
                    } else {
                        console.log("error: " + http.status)
                        callback(null);
                    }
                }
            };
            http.send(null);
        };
    }

    function getFacebookAlbums(accessToken, callback) {
        var http = new XMLHttpRequest()
        var url = "https://graph.facebook.com/me?fields=albums.fields(id,name)&access_token=" + accessToken;
        //console.log('url: \n' + url)
        http.open("GET", url, true);
        var albums = [];
        http.onreadystatechange = function() {
            if (http.readyState === 4){
                if (http.status == 200) {
                    var response = JSON.parse(http.responseText);
                    for (i = 0; i<response['albums']['data'].length; i++ ) {
                        var name = JSON.stringify(response['albums']['data'][i]['name']);
                        var id = JSON.stringify(response['albums']['data'][i]['id']);
                        albums.push({'id': id, 'name': name});
                    }

                    callback(albums);
                } else {
                    console.log("error: " + http.status)
                    callback(null);
                }
            }
        };
        http.send(null);
    }

    function setResults(data) {
        var results = document.getElementById('results');
        results.innerHTML = data;
    };
}; //onload
