/**
 * Load the DOM, then initialize the Ubuntu UI layer
 */
window.onload = function () {
    var UI = new UbuntuUI();
    UI.init();
    UI.pagestack.push('main');

    UI.button('listAccounts').click(listAccounts);

    var lname = UI.list('#nname');
    var lprovider = UI.list('#nprovider');
    var lservice = UI.list('#nservice');
    var lresults = UI.list('#nresults');
    var api = external.getUnityObject('1.0');
    var oa = api.OnlineAccounts;
    var gresults = {};

    function listAccounts() {

        var filters = {};
        var service = document.getElementById('service').value;
        if (service) {
            filters['service'] = service
        }
        var provider = document.getElementById('provider').value;
        if (provider) {
            filters['provider'] = provider
        }
        var accountsList = UI.list('#accounts');
        accountsList.removeAllItems();

        oa.api.getAccounts(filters, function(accounts) {

            if (accounts.length === 0) {
                accountsList.append('No accounts found');
            }
            else {
                accountsList.setHeader('Click to Authenticate and see detail');
                for(var i = 0; i < accounts.length; ++i) {
                    var act = accounts[i];
                    var mod = {
                        'name': act.displayName(),
                        'prov': act.provider(),
                        'serv': act.service(),
                        'lname': lname,
                        'lprovider': lprovider,
                        'lservice': lservice,
                        'lresults': lresults,
                        'act': act
                    }
                    var dL = displayList(mod);

                    console.log('act provider\n: ' + JSON.stringify(act.provider()));
                    console.log('act service\n: ' + JSON.stringify(act.service()));

                    var info =
                            act.displayName() + ' '
                            + JSON.stringify((act.provider()['id'])) + ' '
                            + JSON.stringify(act.service()['id']);
                    accountsList.append(
                            info,
                            null,
                            null,
                            dL
                    ); // accountsList.append()
                  } //for loop
               } //else
            } //getAccounts anon func
        ); //getAccounts
    } //listAccounts

    function displayList(mod) {
        return ( function() {
            UI.pagestack.push('actdetails');
            var sR = showRaw(mod);
            mod['lname'].removeAllItems();
            mod['lname'].append(mod['name'], null, null, sR);
            _display(mod['lprovider'],mod['prov'], false, '');
            _display(mod['lservice'],mod['serv'], false, '');

            function _display(list, obj, append, prepend) {
                if (! append) {list.removeAllItems();}
                var keys = Object.keys(obj);
                for (ky in keys) {
                    list.append( prepend + keys[ky] + ':' + obj[keys[ky]], null, null, sR );
                }// for loop
            } //_display()

            mod['act'].authenticate(
                function (results) {
                    gresults = results;
                    _display(mod['lresults'], results, false, '');
                    _display(mod['lresults'], results['data'], true, 'data:');

                } //callback
            );
         });
    }

    function showRaw(mod) {
        return (function () {
            UI.pagestack.push('raw');
            console.log('Auth: ' + JSON.stringify(gresults));
            document.getElementById('rawprovider').innerHTML='<div><p>Provider: ' + JSON.stringify(mod['prov']) + '<p></div>';
            document.getElementById('rawservice').innerHTML='<p>Service: ' + JSON.stringify(mod['serv']) + '</p>';
            document.getElementById('rawauth').innerHTML='<div><p>Auth: ' + JSON.stringify(gresults) + '</p></div>';
        });
    }
};
