/*
 * Copyright (C) 2014 Canonical
 * Author: Kyle Nitzsche <kyle.nitzsche@canonical.com>
 *
 * This package is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 3 of the 
 * License, or
 * (at your option) any later version.
 *
 * This package is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this program. If not, see 
 * <http://www.gnu.org/licenses/>
 */

/*
 * Wait before the DOM has been loaded before initializing the Ubuntu UI layer
 * Using http://glosbe.com/a-api to get data
 */
$( document ).ready(function() {
    var UI = new UbuntuUI();
    UI.init();

    UI.button('lookup').click(function () {
      var lookup = document.getElementById('word').value;
      console.log('Looking up: ' + lookup);
      var url = "http://glosbe.com/gapi/translate?from=eng&dest=eng&format=json&phrase=" + lookup + "&pretty=true";
      $.ajax({
        type: 'GET',
        url: url,
        success: success,
        dataType:'jsonp',
        contentType: "application/json"
      });
    });
});

function success( data ){
  console.log('AJAX success.');

  var resEl = document.getElementById('res');
  var res ='<header>Meanings</header><ul>';

  for ( var idx1 = 0; idx1 < data.tuc.length; idx1++ ) {
    if ( data.tuc[idx1].meanings ) {
      console.log('meanings');
      for ( var idx2 = 0; idx2 < data.tuc[idx1].meanings.length; idx2++ ) {
        if ( data.tuc[idx1].meanings[idx2].text ) {
          console.log( data.tuc[idx1].meanings[idx2].text );
          res += '<li>' + data.tuc[idx1].meanings[idx2].text + '</li>';
        }
      }
    }
  }
  resEl.innerHTML = res + '</ul>';
}
